import * as iam from 'aws-cdk-lib/aws-iam';
import * as lambda from 'aws-cdk-lib/aws-lambda';
import { CfnSchedule } from 'aws-cdk-lib/aws-scheduler';
import { ScheduleTargetInput } from '../input';
import { ISchedule } from '../schedule';
/**
 * DISCLAIMER: WORK IN PROGRESS, INTERFACE MIGHT CHANGE
 *
 * This unit is not yet finished. The LambaInvoke target is only implemented to be able
 * to create some sensible unit tests.
 */
export declare namespace targets {
    export interface ScheduleTargetBaseProps {
        readonly role?: iam.IRole;
        readonly input?: ScheduleTargetInput;
    }
    abstract class ScheduleTargetBase {
        private readonly baseProps;
        protected readonly targetArn: string;
        constructor(baseProps: ScheduleTargetBaseProps, targetArn: string);
        protected abstract addTargetActionToRole(role: iam.IRole): void;
        protected bindBaseTargetConfig(_schedule: ISchedule): CfnSchedule.TargetProperty;
        bind(schedule: ISchedule): CfnSchedule.TargetProperty;
    }
    export class LambdaInvoke extends ScheduleTargetBase {
        private readonly func;
        constructor(baseProps: ScheduleTargetBaseProps, func: lambda.IFunction);
        protected addTargetActionToRole(role: iam.IRole): void;
    }
    export {};
}
